package exnihilocreatio.client.models;

import exnihilocreatio.blocks.BlockInfestingLeaves;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.block.model.*;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.common.property.IExtendedBlockState;
import org.apache.commons.lang3.tuple.Pair;

import javax.annotation.Nullable;
import javax.vecmath.Matrix4f;
import java.util.List;

import static exnihilocreatio.ModBlocks.infestedLeaves;


public class InfestedLeavesBakedModel implements IBakedModel {

    public final static ModelResourceLocation variantTag = new ModelResourceLocation(infestedLeaves.getRegistryName(), "normal");
    private final IBakedModel defaultModel;
    private TextureAtlasSprite particleTexture;

    public InfestedLeavesBakedModel(IBakedModel defaultModel) {
        this.defaultModel = defaultModel;
    }

    private IBakedModel handleBlockState(IBlockState state) {
        if (state instanceof IExtendedBlockState) {
            IBlockState copiedState = BlockInfestingLeaves.getLeafState(state);

            this.particleTexture = Minecraft.func_71410_x().func_175602_ab().func_175023_a().func_178125_b(copiedState).func_177554_e();
            return Minecraft.func_71410_x().func_175602_ab().func_175023_a().func_178125_b(copiedState);
        }
        return defaultModel;
    }

    @Override
    public TextureAtlasSprite func_177554_e() {
        return this.particleTexture;
    }


    @Override
    public List<BakedQuad> func_188616_a(@Nullable IBlockState state, @Nullable EnumFacing side, long rand) {
        return handleBlockState(state).func_188616_a(state, side, rand);
    }

    @Override
    public ItemCameraTransforms func_177552_f() {
        return defaultModel.func_177552_f();
    }

    @Override
    public boolean func_188618_c() {
        return defaultModel.func_188618_c();
    }

    @Override
    public boolean func_177555_b() {
        return defaultModel.func_177555_b();
    }

    @Override
    public boolean func_177556_c() {
        return defaultModel.func_177556_c();
    }

    @Override
    public ItemOverrideList func_188617_f() {
        return defaultModel.func_188617_f();
    }

    @Override
    public Pair<? extends IBakedModel, Matrix4f> handlePerspective(ItemCameraTransforms.TransformType cameraTransformType) {
        return Pair.of(this, defaultModel.handlePerspective(cameraTransformType).getRight());
    }
}
