package exnihilocreatio.client.renderers;

import exnihilocreatio.blocks.BlockGrinder;
import exnihilocreatio.blocks.EnumGrinderParts;
import exnihilocreatio.tiles.TileGrinder;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.EnumFacing;
import org.lwjgl.opengl.GL11;

import java.util.List;

public class RenderGrinder extends TileEntitySpecialRenderer<TileGrinder> {
    private static List<BakedQuad> quadsBox;
    private static List<BakedQuad> quadsGear;
    private static List<BakedQuad> quadsShaft;

    @Override
    public void func_192841_a(TileGrinder te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        // GlStateManager.pushAttrib();
        // GlStateManager.pushMatrix();

        // Translate to the location of our tile entity
        // GlStateManager.translate(x, y, z);

        renderGear(te, x, y, z, partialTicks);
        renderRod(te, x, y, z, partialTicks);
        renderBox(te, x, y, z);

        // GlStateManager.popMatrix();
        // GlStateManager.popAttrib();

    }

    void renderGear(TileGrinder tile, double x, double y, double z, float partialTicks) {
        if (quadsGear == null) {
            final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
            IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockGrinder.PART_TYPE, EnumGrinderParts.GEAR);

            quadsGear = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        }

        Tessellator tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179137_b(0.5, 0.5, 0.5);
        GlStateManager.func_179139_a(0.5, 0.5, 0.5);

        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();


        // float rotFacing = tile.facing == EnumFacing.SOUTH ? 180 : tile.facing == EnumFacing.WEST ? 90 : tile.facing == EnumFacing.EAST ? -90 : 0;
        // GlStateManager.rotate(rotFacing, 0, 1, 0);

        float rot = 360F - ((tile.rotationValue + tile.perTickRotation * partialTicks) % 360F);
        GlStateManager.func_179114_b(rot, 0, 1, 0);

        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsGear, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }

    void renderRod(TileGrinder tile, double x, double y, double z, float partialTicks) {
        if (quadsShaft == null) {
            final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
            IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockGrinder.PART_TYPE, EnumGrinderParts.ROD);

            quadsShaft = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        }

        Tessellator tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179137_b(0.5, 0.5, 0.5);
        GlStateManager.func_179139_a(0.5, 0.5, 0.5);


        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();


        float rotFacing = tile.facing == EnumFacing.SOUTH ? 180 : tile.facing == EnumFacing.WEST ? 90 : tile.facing == EnumFacing.EAST ? -90 : 0;
        GlStateManager.func_179114_b(rotFacing, 0, 1, 0);

        float rot = (tile.rotationValue + tile.perTickRotation * partialTicks) % 360;
        GlStateManager.func_179114_b(rot, 0, 0, 1);

        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsShaft, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }

    void renderBox(TileGrinder tile, double x, double y, double z) {
        if (quadsBox == null) {
            final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
            IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockGrinder.PART_TYPE, EnumGrinderParts.BOX);

            quadsBox = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        }

        Tessellator tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179137_b(0.5, 0.5, 0.5);
        GlStateManager.func_179139_a(0.5, 0.5, 0.5);


        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();


        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsBox, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }
}
