package exnihilocreatio.compatibility.jei.crucible;

import exnihilocreatio.ModBlocks;
import exnihilocreatio.blocks.BlockCrucibleStone;
import exnihilocreatio.util.BlockInfo;
import exnihilocreatio.util.RenderTickCounter;
import mezz.jei.api.ingredients.IIngredients;
import mezz.jei.api.recipe.IRecipeWrapper;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.texture.TextureManager;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraftforge.client.ForgeHooksClient;
import net.minecraftforge.fluids.*;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;

import java.awt.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

// Credit goes to >>>> https://github.com/thraaawn/CompactMachines/blob/1.12.1/src/main/java/org/dave/compactmachines3/jei/MultiblockRecipeWrapper.java
public class HeatSourcesRecipe implements IRecipeWrapper {
    private final List<ItemStack> inputs;
    private final BlockInfo blockInfo;
    private final String heatAmountString;

    public HeatSourcesRecipe(BlockInfo blockInfo, int heatAmount) {
        this.blockInfo = blockInfo;


        ItemStack item = blockInfo.getItemStack();
        if (item.func_190926_b()) {
            Fluid fluid = null;
            Block block = blockInfo.getBlock();
            if (block instanceof IFluidBlock) {
                fluid = ((IFluidBlock) block).getFluid();
            }
            if (block == Blocks.field_150353_l || block == Blocks.field_150356_k) {
                fluid = FluidRegistry.LAVA;
            }
            if (block == Blocks.field_150355_j || block == Blocks.field_150358_i) {
                fluid = FluidRegistry.WATER;
            }
            if (fluid != null) {
                item = FluidUtil.getFilledBucket(new FluidStack(fluid, 1000));
            }
            if (block == Blocks.field_150480_ab) {
                item = new ItemStack(Items.field_151033_d, 1);
            }
        }


        inputs = new ArrayList<>(Collections.singleton(item));
        heatAmountString = String.valueOf(heatAmount) + "x";
    }

    @Override
    public void getIngredients(IIngredients ingredients) {
        ingredients.setInputs(ItemStack.class, inputs);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void drawInfo(Minecraft minecraft, int recipeWidth, int recipeHeight, int mouseX, int mouseY) {
        minecraft.field_71466_p.func_78276_b(heatAmountString, 24, 12, Color.gray.getRGB());

        // int reqX = (int) Math.ceil((float)(maxPos.getX() - minPos.getX() +2) / 2.0f);
        // int reqZ = (int) Math.ceil((float)(maxPos.getZ() - minPos.getZ() +2) / 2.0f);


        GlStateManager.func_179094_E();
        GlStateManager.func_179109_b(0F, 0F, 216.5F);


        // minecraft.fontRenderer.drawString(recipe.getDimensionsString(), 153-mc.fontRenderer.getStringWidth(recipe.getDimensionsString()), 19 * 5 + 10, 0x444444);

        GlStateManager.func_179121_F();

        float angle = RenderTickCounter.renderTicks * 45.0f / 128.0f;

        // When we want to render translucent blocks we might need this
        BlockRendererDispatcher blockrendererdispatcher = Minecraft.func_71410_x().func_175602_ab();

        // Init GlStateManager
        TextureManager textureManager = Minecraft.func_71410_x().func_110434_K();
        textureManager.func_110577_a(TextureMap.field_110575_b);
        textureManager.func_110581_b(TextureMap.field_110575_b).func_174936_b(false, false);
        GlStateManager.func_179138_g(OpenGlHelper.field_77476_b);
        GlStateManager.func_179138_g(OpenGlHelper.field_77478_a);
        GlStateManager.func_179141_d();
        GlStateManager.func_179092_a(GL11.GL_GREATER, 0.1f);
        GlStateManager.func_179147_l();
        GlStateManager.func_187401_a(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA);
        GlStateManager.func_179131_c(1.0f, 1.0f, 1.0f, 1.0f);
        GlStateManager.func_179106_n();
        GlStateManager.func_179140_f();
        RenderHelper.func_74518_a();
        GlStateManager.func_179147_l();
        GlStateManager.func_179089_o();
        GlStateManager.func_179141_d();
        if (Minecraft.func_71379_u()) {
            GlStateManager.func_179103_j(7425);
        } else {
            GlStateManager.func_179103_j(7424);
        }

        GlStateManager.func_179094_E();

        // Center on recipe area
        GlStateManager.func_179109_b(70, 30, 20);

        // Shift it a bit down so one can properly see 3d
        GlStateManager.func_179114_b(-25.0f, 1.0f, 0.0f, 0.0f);

        // Rotate per our calculated time
        GlStateManager.func_179114_b(angle, 0.0f, 1.0f, 0.0f);

        // Scale down to gui scale
        GlStateManager.func_179152_a(16.0f, -16.0f, 16.0f);

        Tessellator tessellator = Tessellator.func_178181_a();
        BufferBuilder buffer = tessellator.func_178180_c();

        buffer.func_178969_c(-.5, 0, -.5);

        GlStateManager.func_179089_o();

        IBlockState crucible = ModBlocks.crucibleStone.func_176223_P().func_177226_a(BlockCrucibleStone.FIRED, true);
        IBlockState state = blockInfo.getBlock().getDefaultState();

        BlockPos pos = new BlockPos(0, 0, 0);
        /*if (blockInfo.getBlock() instanceof IFluidBlock || blockInfo.getBlock() instanceof BlockLiquid) {
            pos = pos.up();
        }*/


        // Aaaand render
        buffer.func_181668_a(7, DefaultVertexFormats.field_176600_a);
        GlStateManager.func_179118_c();
        this.renderBlock(blockrendererdispatcher, buffer, BlockRenderLayer.SOLID, crucible, new BlockPos(0, 1, 0), minecraft.field_71441_e);

        this.renderBlock(blockrendererdispatcher, buffer, BlockRenderLayer.SOLID, state, pos, minecraft.field_71441_e);
        GlStateManager.func_179141_d();
        this.renderBlock(blockrendererdispatcher, buffer, BlockRenderLayer.CUTOUT_MIPPED, state, pos, minecraft.field_71441_e);
        this.renderBlock(blockrendererdispatcher, buffer, BlockRenderLayer.CUTOUT, state, pos, minecraft.field_71441_e);
        GlStateManager.func_179103_j(7425);
        this.renderBlock(blockrendererdispatcher, buffer, BlockRenderLayer.TRANSLUCENT, state, pos, minecraft.field_71441_e);
        tessellator.func_78381_a();

        buffer.func_178969_c(0, 0, 0);
        GlStateManager.func_179121_F();
    }

    @SideOnly(Side.CLIENT)
    public void renderBlock(BlockRendererDispatcher blockrendererdispatcher, BufferBuilder buffer, BlockRenderLayer renderLayer, IBlockState blockState, BlockPos pos, IBlockAccess access) {

        if (!blockState.func_177230_c().canRenderInLayer(blockState, renderLayer)) {
            return;
        }

        ForgeHooksClient.setRenderLayer(renderLayer);

        try {
            blockrendererdispatcher.func_175018_a(blockState, pos, access, buffer);
        } catch (Exception e) {
            e.printStackTrace();
        }

        ForgeHooksClient.setRenderLayer(null);
    }
}
